<?php
namespace Alloy\View\Helper;

/**
 * Data Helper
 * Useful data array of commonly required information for HTML forms
 * 
 * @package Alloy
 * @license http://www.opensource.org/licenses/bsd-license.php
 * @link http://alloyframework.com/
 */
class Data extends HelperAbstract
{
    /**
     * Array list of countries with country codes
     */
    public function countries()
    {
        return array(
            'US' => 'United States of America',
            'UK' => 'United Kingdom',
            'CA' => 'Canada',
            'AU' => 'Australia',
            'AF' => 'Afghanistan',
            'AL' => 'Albania',
            'DZ' => 'Algeria',
            'AS' => 'American Samoa',
            'AD' => 'Andorra',
            'AO' => 'Angola',
            'AI' => 'Anguilla',
            'AG' => 'Antigua & Barbuda',
            'AR' => 'Argentina',
            'AM' => 'Armenia',
            'AW' => 'Aruba',
            'AT' => 'Austria',
            'AZ' => 'Azerbaijan',
            'AP' => 'Azores',
            'BS' => 'Bahamas',
            'BH' => 'Bahrain',
            'BD' => 'Bangladesh',
            'BB' => 'Barbados',
            'BY' => 'Belarus',
            'BE' => 'Belgium',
            'BZ' => 'Belize',
            'BJ' => 'Benin',
            'BM' => 'Bermuda',
            'BT' => 'Bhutan',
            'BO' => 'Bolivia',
            'BL' => 'Bonaire',
            'BA' => 'Bosnia & Herzegovina',
            'BW' => 'Botswana',
            'BR' => 'Brazil',
            'IO' => 'British Indian Ocean Ter',
            'BN' => 'Brunei',
            'BG' => 'Bulgaria',
            'BF' => 'Burkina Faso',
            'BI' => 'Burundi',
            'KH' => 'Cambodia',
            'CM' => 'Cameroon',
            'IC' => 'Canary Islands',
            'CV' => 'Cape Verde',
            'KY' => 'Cayman Islands',
            'CF' => 'Central African Republic',
            'TD' => 'Chad',
            'JI' => 'Channel Islands',
            'CL' => 'Chile',
            'CN' => 'China',
            'CX' => 'Christmas Island',
            'CC' => 'Cocos Island',
            'CO' => 'Columbia',
            'KM' => 'Comoros',
            'CG' => 'Congo',
            'CD' => 'Congo Democratic Republic',
            'CK' => 'Cook Islands',
            'CR' => 'Costa Rica',
            'CI' => 'Cote D Ivoire',
            'HR' => 'Croatia',
            'CU' => 'Cuba',
            'CB' => 'Curacao',
            'CY' => 'Cyprus',
            'CZ' => 'Czech Republic',
            'DK' => 'Denmark',
            'DJ' => 'Djibouti',
            'DM' => 'Dominica',
            'DO' => 'Dominican Republic',
            'TL' => 'East Timor',
            'EC' => 'Ecuador',
            'EG' => 'Egypt',
            'SV' => 'El Salvador',
            'GQ' => 'Equatorial Guinea',
            'ER' => 'Eritrea',
            'EE' => 'Estonia',
            'ET' => 'Ethiopia',
            'FK' => 'Falkland Islands',
            'FO' => 'Faroe Islands',
            'FJ' => 'Fiji',
            'FI' => 'Finland',
            'FR' => 'France',
            'GF' => 'French Guiana',
            'PF' => 'French Polynesia',
            'TF' => 'French Southern Ter',
            'GA' => 'Gabon',
            'GM' => 'Gambia',
            'GE' => 'Georgia',
            'DE' => 'Germany',
            'GH' => 'Ghana',
            'GI' => 'Gibraltar',
            'GB' => 'Great Britain',
            'GR' => 'Greece',
            'GL' => 'Greenland',
            'GD' => 'Grenada',
            'GP' => 'Guadeloupe',
            'GU' => 'Guam',
            'GT' => 'Guatemala',
            'GN' => 'Guinea',
            'GW' => 'Guinea Bissau',
            'GY' => 'Guyana',
            'HT' => 'Haiti',
            'HW' => 'Hawaii',
            'HN' => 'Honduras',
            'HK' => 'Hong Kong',
            'HU' => 'Hungary',
            'IS' => 'Iceland',
            'IN' => 'India',
            'ID' => 'Indonesia',
            'IR' => 'Iran',
            'IQ' => 'Iraq',
            'IE' => 'Ireland',
            'IM' => 'Isle of Man',
            'IL' => 'Israel',
            'IT' => 'Italy',
            'JM' => 'Jamaica',
            'JP' => 'Japan',
            'JO' => 'Jordan',
            'KZ' => 'Kazakhstan',
            'KE' => 'Kenya',
            'KI' => 'Kiribati',
            'NK' => 'Korea North',
            'KS' => 'Korea South',
            'KW' => 'Kuwait',
            'KG' => 'Kyrgyzstan',
            'LA' => 'Laos',
            'LV' => 'Latvia',
            'LB' => 'Lebanon',
            'LS' => 'Lesotho',
            'LR' => 'Liberia',
            'LY' => 'Libya',
            'LI' => 'Liechtenstein',
            'LT' => 'Lithuania',
            'LU' => 'Luxembourg',
            'MO' => 'Macau',
            'MK' => 'Macedonia',
            'MG' => 'Madagascar',
            'MW' => 'Malawi',
            'MY' => 'Malaysia',
            'MV' => 'Maldives',
            'ML' => 'Mali',
            'MT' => 'Malta',
            'MH' => 'Marshall Islands',
            'MQ' => 'Martinique',
            'MR' => 'Mauritania',
            'MU' => 'Mauritius',
            'YT' => 'Mayotte',
            'MX' => 'Mexico',
            'FM' => 'Micronesia',
            'MI' => 'Midway Islands',
            'MD' => 'Moldova',
            'MC' => 'Monaco',
            'MN' => 'Mongolia',
            'MS' => 'Montserrat',
            'MA' => 'Morocco',
            'MZ' => 'Mozambique',
            'MM' => 'Myanmar',
            'NA' => 'Nambia',
            'NR' => 'Nauru',
            'NP' => 'Nepal',
            'AN' => 'Netherland Antilles',
            'NL' => 'Netherlands',
            'NC' => 'New Caledonia',
            'NZ' => 'New Zealand',
            'NI' => 'Nicaragua',
            'NE' => 'Niger',
            'NG' => 'Nigeria',
            'NU' => 'Niue',
            'NF' => 'Norfolk Island',
            'NO' => 'Norway',
            'OM' => 'Oman',
            'PK' => 'Pakistan',
            'PW' => 'Palau Island',
            'PS' => 'Palestine',
            'PA' => 'Panama',
            'PG' => 'Papua New Guinea',
            'PY' => 'Paraguay',
            'PE' => 'Peru',
            'PH' => 'Philippines',
            'PN' => 'Pitcairn Island',
            'PL' => 'Poland',
            'PT' => 'Portugal',
            'PR' => 'Puerto Rico',
            'QA' => 'Qatar',
            'RE' => 'Reunion',
            'RO' => 'Romania',
            'RU' => 'Russia',
            'RW' => 'Rwanda',
            'WS' => 'Samoa',
            'SM' => 'San Marino',
            'ST' => 'Sao Tome & Principe',
            'SA' => 'Saudi Arabia',
            'SN' => 'Senegal',
            'CS' => 'Serbia & Montenegro',
            'SC' => 'Seychelles',
            'SL' => 'Sierra Leone',
            'SG' => 'Singapore',
            'SK' => 'Slovakia',
            'SI' => 'Slovenia',
            'SB' => 'Solomon Islands',
            'SO' => 'Somalia',
            'ZA' => 'South Africa',
            'ES' => 'Spain',
            'LK' => 'Sri Lanka',
            'SH' => 'St Helena',
            'KN' => 'St Kitts-Nevis',
            'LC' => 'St Lucia',
            'MB' => 'St Maarten',
            'PM' => 'St Pierre & Miquelon',
            'VC' => 'St Vincent & Grenadines',
            'SD' => 'Sudan',
            'SR' => 'Suriname',
            'SJ' => 'Svalbard',
            'SZ' => 'Swaziland',
            'SE' => 'Sweden',
            'CH' => 'Switzerland',
            'SY' => 'Syria',
            'TA' => 'Tahiti',
            'TW' => 'Taiwan',
            'TJ' => 'Tajikistan',
            'TZ' => 'Tanzania',
            'TH' => 'Thailand',
            'TG' => 'Togo',
            'TK' => 'Tokelau',
            'TO' => 'Tonga',
            'TT' => 'Trinidad & Tobago',
            'TN' => 'Tunisia',
            'TR' => 'Turkey',
            'TM' => 'Turkmenistan',
            'TC' => 'Turks & Caicos Is',
            'TV' => 'Tuvalu',
            'UG' => 'Uganda',
            'UA' => 'Ukraine',
            'AE' => 'United Arab Emirates',
            'UY' => 'Uruguay',
            'UZ' => 'Uzbekistan',
            'VU' => 'Vanuatu',
            'VS' => 'Vatican City State',
            'VE' => 'Venezuela',
            'VN' => 'Vietnam',
            'VG' => 'Virgin Islands (Brit)',
            'VI' => 'Virgin Islands (USA)',
            'WK' => 'Wake Island',
            'WF' => 'Wallis & Futana Is',
            'EH' => 'Western Sahara',
            'YE' => 'Yemen',
            'ZM' => 'Zambia',
            'ZW' => 'Zimbabwe'
        );
    }

    
    /**
     * List of States in the United States of America
     */
    public function states()
    {
        return array(
            'AL' => 'Alabama',
            'AK' => 'Alaska',
            'AZ' => 'Arizona',
            'AR' => 'Arkansas',
            'CA' => 'California',
            'CO' => 'Colorado',
            'CT' => 'Connecticut',
            'DE' => 'Delaware',
            'DC' => 'District of Columbia',
            'FL' => 'Florida',
            'GA' => 'Georgia',
            'HI' => 'Hawaii',
            'ID' => 'Idaho',
            'IL' => 'Illinois',
            'IN' => 'Indiana',
            'IA' => 'Iowa',
            'KS' => 'Kansas',
            'KY' => 'Kentucky',
            'LA' => 'Louisiana',
            'ME' => 'Maine',
            'MD' => 'Maryland',
            'MA' => 'Massachusetts',
            'MI' => 'Michigan',
            'MN' => 'Minnesota',
            'MS' => 'Mississippi',
            'MO' => 'Missouri',
            'MT' => 'Montana',
            'NE' => 'Nebraska',
            'NV' => 'Nevada',
            'NH' => 'New Hampshire',
            'NJ' => 'New Jersey',
            'NM' => 'New Mexico',
            'NY' => 'New York',
            'ND' => 'North Dakota',
            'NC' => 'North Carolina',
            'OH' => 'Ohio',
            'OK' => 'Oklahoma',
            'OR' => 'Oregon',
            'PA' => 'Pennsylvania',
            'RI' => 'Rhode Island',
            'SC' => 'South Carolina',
            'SD' => 'South Dakota',
            'TN' => 'Tennessee',
            'TX' => 'Texas',
            'UT' => 'Utah',
            'VT' => 'Vermont',
            'VA' => 'Virginia',
            'WA' => 'Washington',
            'WV' => 'West Virginia',
            'WI' => 'Wisconsin',
            'WY' => 'Wyoming'
        );
    }
    

    /**
     * List of Canadian provinces
     */
    public function provinces() 
    {
        return array(
            'AB' => 'Alberta',
            'BC' => 'British Columbia',
            'MB' => 'Manitoba',
            'NB' => 'New Brunswick',
            'NF' => 'Newfoundland',
            'NU' => 'Nunavut',
            'NS' => 'Nova Scotia',
            'NT' => 'Northwest Territories',
            'ON' => 'Ontario',
            'PE' => 'Prince Edward Island',
            'QC' => 'Quebec',
            'SK' => 'Saskatchewan',
            'YT' => 'Yukon Territories'
        );
    }
    

    /**
     * Months of the year (english)
     */
    public function months()
    {
        return array(
            '01' => 'January',
            '02' => 'February',
            '03' => 'March',
            '04' => 'April',
            '05' => 'May',
            '06' => 'June',
            '07' => 'July',
            '08' => 'August',
            '09' => 'September',
            '10' => 'October',
            '11' => 'November',
            '12' => 'December'
        );
    }
    
    
    /**
     * Locales and their codes
     */
    public function locales()
    {
        return array(
            'af' => 'Afrikaans',
            'af_ZA' => 'Afrikaans - South Africa',
            'sq' => 'Albanian',
            'sq_AL' => 'Albanian - Albania',
            'ar' => 'Arabic',
            'ar_DZ' => 'Arabic - Algeria',
            'ar_BH' => 'Arabic - Bahrain',
            'ar_EG' => 'Arabic - Egypt',
            'ar_IQ' => 'Arabic - Iraq',
            'ar_JO' => 'Arabic - Jordan',
            'ar_KW' => 'Arabic - Kuwait',
            'ar_LB' => 'Arabic - Lebanon',
            'ar_LY' => 'Arabic - Libya',
            'ar_MA' => 'Arabic - Morocco',
            'ar_OM' => 'Arabic - Oman',
            'ar_QA' => 'Arabic - Qatar',
            'ar_SA' => 'Arabic - Saudi Arabia',
            'ar_SY' => 'Arabic - Syria',
            'ar_TN' => 'Arabic - Tunisia',
            'ar_AE' => 'Arabic - United Arab Emirates',
            'ar_YE' => 'Arabic - Yemen',
            'hy' => 'Armenian',
            'hy_AM' => 'Armenian - Armenia',
            'az' => 'Azeri',
            'az_AZ-Cyrl' => 'Azeri (Cyrillic) - Azerbaijan',
            'az_AZ-Latn' => 'Azeri (Latin) - Azerbaijan',
            'eu' => 'Basque',
            'eu_ES' => 'Basque - Basque',
            'be' => 'Belarusian',
            'be_BY' => 'Belarusian - Belarus',
            'bg' => 'Bulgarian',
            'bg_BG' => 'Bulgarian - Bulgaria',
            'ca' => 'Catalan',
            'ca_ES' => 'Catalan - Catalan',
            'zh_HK' => 'Chinese - Hong Kong SAR',
            'zh_MO' => 'Chinese - Macao SAR',
            'zh_CN' => 'Chinese - China',
            'zh_CHS' => 'Chinese (Simplified)',
            'zh_SG' => 'Chinese - Singapore',
            'zh_TW' => 'Chinese - Taiwan',
            'zh_CHT' => 'Chinese (Traditional)',
            'hr' => 'Croatian',
            'hr_HR' => 'Croatian - Croatia',
            'cs' => 'Czech',
            'cs_CZ' => 'Czech - Czech Republic',
            'da' => 'Danish',
            'da_DK' => 'Danish - Denmark',
            'div' => 'Dhivehi',
            'div_MV' => 'Dhivehi - Maldives',
            'nl' => 'Dutch',
            'nl_BE' => 'Dutch - Belgium',
            'nl_NL' => 'Dutch - The Netherlands',
            'en' => 'English',
            'en_AU' => 'English - Australia',
            'en_BZ' => 'English - Belize',
            'en_CA' => 'English - Canada',
            'en_CB' => 'English - Caribbean',
            'en_IE' => 'English - Ireland',
            'en_JM' => 'English - Jamaica',
            'en_NZ' => 'English - New Zealand',
            'en_PH' => 'English - Philippines',
            'en_ZA' => 'English - South Africa',
            'en_TT' => 'English - Trinidad and Tobago',
            'en_GB' => 'English - United Kingdom',
            'en_US' => 'English - United States',
            'en_ZW' => 'English - Zimbabwe',
            'et' => 'Estonian',
            'et_EE' => 'Estonian - Estonia',
            'fo' => 'Faroese',
            'fo_FO' => 'Faroese - Faroe Islands',
            'fa' => 'Farsi',
            'fa_IR' => 'Farsi - Iran',
            'fi' => 'Finnish',
            'fi_FI' => 'Finnish - Finland',
            'fr' => 'French',
            'fr_BE' => 'French - Belgium',
            'fr_CA' => 'French - Canada',
            'fr_FR' => 'French - France',
            'fr_LU' => 'French - Luxembourg',
            'fr_MC' => 'French - Monaco',
            'fr_CH' => 'French - Switzerland',
            'gl' => 'Galician',
            'gl_ES' => 'Galician - Galician',
            'ka' => 'Georgian',
            'ka_GE' => 'Georgian - Georgia',
            'de' => 'German',
            'de_AT' => 'German - Austria',
            'de_DE' => 'German - Germany',
            'de_LI' => 'German - Liechtenstein',
            'de_LU' => 'German - Luxembourg',
            'de_CH' => 'German - Switzerland',
            'el' => 'Greek',
            'el_GR' => 'Greek - Greece',
            'gu' => 'Gujarati',
            'gu_IN' => 'Gujarati - India',
            'he' => 'Hebrew',
            'he_IL' => 'Hebrew - Israel',
            'hi' => 'Hindi',
            'hi_IN' => 'Hindi - India',
            'hu' => 'Hungarian',
            'hu_HU' => 'Hungarian - Hungary',
            'is' => 'Icelandic',
            'is_IS' => 'Icelandic - Iceland',
            'id' => 'Indonesian',
            'id_ID' => 'Indonesian - Indonesia',
            'it' => 'Italian',
            'it_IT' => 'Italian - Italy',
            'it_CH' => 'Italian - Switzerland',
            'ja' => 'Japanese',
            'ja_JP' => 'Japanese - Japan',
            'kn' => 'Kannada',
            'kn_IN' => 'Kannada - India',
            'kk' => 'Kazakh',
            'kk_KZ' => 'Kazakh - Kazakhstan',
            'kok' => 'Konkani',
            'kok_IN' => 'Konkani - India',
            'ko' => 'Korean',
            'ko_KR' => 'Korean - Korea',
            'ky' => 'Kyrgyz',
            'ky_KG' => 'Kyrgyz - Kyrgyzstan',
            'lv' => 'Latvian',
            'lv_LV' => 'Latvian - Latvia',
            'lt' => 'Lithuanian',
            'lt_LT' => 'Lithuanian - Lithuania',
            'mk' => 'Macedonian',
            'mk_MK' => 'Macedonian - Former Yugoslav Republic of Macedonia',
            'ms' => 'Malay',
            'ms_BN' => 'Malay - Brunei',
            'ms_MY' => 'Malay - Malaysia',
            'mr' => 'Marathi',
            'mr_IN' => 'Marathi - India',
            'mn' => 'Mongolian',
            'mn_MN' => 'Mongolian - Mongolia',
            'no' => 'Norwegian',
            'nb_NO' => 'Norwegian (Bokm',
            'nn_NO' => 'Norwegian (Nynorsk) - Norway',
            'pl' => 'Polish',
            'pl_PL' => 'Polish - Poland',
            'pt' => 'Portuguese',
            'pt_BR' => 'Portuguese - Brazil',
            'pt_PT' => 'Portuguese - Portugal',
            'pa' => 'Punjabi',
            'pa_IN' => 'Punjabi - India',
            'ro' => 'Romanian',
            'ro_RO' => 'Romanian - Romania',
            'ru' => 'Russian',
            'ru_RU' => 'Russian - Russia',
            'sa' => 'Sanskrit',
            'sa_IN' => 'Sanskrit - India',
            'sr_SP-Cyrl' => 'Serbian (Cyrillic) - Serbia',
            'sr_SP-Latn' => 'Serbian (Latin) - Serbia',
            'sk' => 'Slovak',
            'sk_SK' => 'Slovak - Slovakia',
            'sl' => 'Slovenian',
            'sl_SI' => 'Slovenian - Slovenia',
            'es' => 'Spanish',
            'es_AR' => 'Spanish - Argentina',
            'es_BO' => 'Spanish - Bolivia',
            'es_CL' => 'Spanish - Chile',
            'es_CO' => 'Spanish - Colombia',
            'es_CR' => 'Spanish - Costa Rica',
            'es_DO' => 'Spanish - Dominican Republic',
            'es_EC' => 'Spanish - Ecuador',
            'es_SV' => 'Spanish - El Salvador',
            'es_GT' => 'Spanish - Guatemala',
            'es_HN' => 'Spanish - Honduras',
            'es_MX' => 'Spanish - Mexico',
            'es_NI' => 'Spanish - Nicaragua',
            'es_PA' => 'Spanish - Panama',
            'es_PY' => 'Spanish - Paraguay',
            'es_PE' => 'Spanish - Peru',
            'es_PR' => 'Spanish - Puerto Rico',
            'es_ES' => 'Spanish - Spain',
            'es_UY' => 'Spanish - Uruguay',
            'es_VE' => 'Spanish - Venezuela',
            'sw' => 'Swahili',
            'sw_KE' => 'Swahili - Kenya',
            'sv' => 'Swedish',
            'sv_FI' => 'Swedish - Finland',
            'sv_SE' => 'Swedish - Sweden',
            'syr' => 'Syriac',
            'syr_SY' => 'Syriac - Syria',
            'ta' => 'Tamil',
            'ta_IN' => 'Tamil - India',
            'tt' => 'Tatar',
            'tt_RU' => 'Tatar - Russia',
            'te' => 'Telugu',
            'te_IN' => 'Telugu - India',
            'th' => 'Thai',
            'th_TH' => 'Thai - Thailand',
            'tr' => 'Turkish',
            'tr_TR' => 'Turkish - Turkey',
            'uk' => 'Ukrainian',
            'uk_UA' => 'Ukrainian - Ukraine',
            'ur' => 'Urdu',
            'ur_PK' => 'Urdu - Pakistan',
            'uz' => 'Uzbek',
            'uz_UZ-Cyrl' => 'Uzbek (Cyrillic) - Uzbekistan',
            'uz_UZ-Latn' => 'Uzbek (Latin) - Uzbekistan',
            'vi' => 'Vietnamese',
            'vi_VN' => 'Vietnamese - Vietnam',
        );
    }
}